#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "SortingAlgorithms.h"

// Swap two values
void swap(Type *a, Type *b)
{
	Type temp = *b;
	*b = *a;
	*a = temp;
}


// Insertion Sort algorithm
void insertionSort(Type data[], int arraySize, BOOL (*compareFunc)(Type a, Type b))
{
}

// Selection Sort Algorithm
void selectionSort(Type data[], int arraySize, BOOL (*compareFunc)(Type a, Type b))
{
}

// Quick Sorting Algorithm
void quickSort(Type data[], int arraySize, BOOL (*compareFunc)(Type a, Type b))
{
	q_sort(data, 0, arraySize - 1, compareFunc);
}

// Recursive function for the quick sort algorithm
void q_sort(Type data[], int left, int right, BOOL (*compareFunc)(Type a, Type b))
{
	Type pivotValue = (Type)0;		// The pivot point value
	int pivot;						// The pivot point index
	int l_hold, r_hold;				// Store the left and right indices before moving

	l_hold = left;
	r_hold = right;
	pivot = left;
	pivotValue = data[pivot];
	while (left < right) {
		// Find the right values that satisfy the comparison function and move them to the left side of the pivot point
		while ((compareFunc(pivotValue, data[right]) == TRUE) && (left < right))
			right--;
		if (left != right) {
			swap(&data[left], &data[right]);
			left++;
		}
		// Find the left values that satisfy the comparison function and move them to the right side point
		while ((compareFunc(pivotValue, data[left]) == FALSE) && (left < right))
			left++;
		if (left != right)
		{
			swap(&data[left], &data[right]);
			right--;
		}
	}
	// Set the leftmost data to hold the pivot value
	data[left] = pivotValue;
	pivot = left;
	left = l_hold;
	right = r_hold;
	// Sort the left part of the pivot
	if (left < pivot)
		q_sort(data, left, pivot - 1, compareFunc);
	// Sort the right part of the pivot
	if (right > pivot)
		q_sort(data, pivot + 1, right, compareFunc);
}


// Heap Sort alogirthm
void heapSort(Type data[], int arraySize, BOOL (*compareFunc)(Type a, Type b))
{
	int i = 0;

	// Build the Heap
	for( i = arraySize / 2; i >= 0; i-- )
		percolateDown(data, i, arraySize, compareFunc );

	// Delete First Element from the heap and put it in the end reducing the size of the heap by one each time
	for( i = arraySize - 1; i > 0; i-- ) {
		swap(&data[0], &data[i]);					// Move min-max element to the end of the array
		percolateDown(data, 0, i, compareFunc );	// Heapify the remaining data
	}
}

void percolateDown(Type data[], int i, int arraySize, BOOL (*compareFunc)(Type a, Type b))
{
	int child;
	Type temp;

	for( temp = data[i]; LEFT_CHILD(i) < arraySize; i = child ) {
		child = LEFT_CHILD(i);
		// Find the min child (or max depending on the comparison function)
		if((child != (arraySize - 1)) && 
		   (compareFunc(data[child + 1], data[child]) == FALSE ))
				child = child + 1;

		if(compareFunc(temp, data[child]) == TRUE )
			data[i] = data[child];
		else
			break;
	}
	data[i] = temp;
}

// Merge Sort Algorithm
void mergeSort(Type data[], int arraySize, BOOL (*compareFunc)(Type a, Type b))
{
	Type *tempArray = NULL;

	tempArray = (Type *)malloc(arraySize * sizeof( Type ));
	if (tempArray == NULL) {
		fprintf(stderr, "Not Enough Memory!!!\n");
		exit(1);
	}

	// Start the sorting
	m_sort( data, tempArray, 0, arraySize - 1, compareFunc);
	free(tempArray);
}

// Sort a subarray using merge sort
void m_sort(Type data[], Type tempArray[], int left, int right, BOOL (*compareFunc)(Type a, Type b))
{
}

// Merge two sorted subarrays
void merge(Type data[], Type tempArray[ ], int leftPos, int rightPos, int rightEnd, BOOL (*compareFunc)(Type a, Type b))
{
}
