#ifndef __SORTING_ALGORITHMS_H__
#define __SORTING_ALGORITHMS_H__

#include "defns.h"

void insertionSort(Type data[], int arraySize, BOOL (*compareFunc)(Type a, Type b));
void selectionSort(Type data[], int arraySize, BOOL (*compareFunc)(Type a, Type b));
void quickSort(Type data[], int arraySize, BOOL (*compareFunc)(Type a, Type b));
void q_sort(Type data[], int left, int right, BOOL (*compareFunc)(Type a, Type b));

void percolateDown(Type data[ ], int i, int arraySize, BOOL (*compareFunc)(Type a, Type b));
void heapSort(Type data[], int arraySize, BOOL (*compareFunc)(Type a, Type b));

void mergeSort(Type data[], int arraySize, BOOL (*compareFunc)(Type a, Type b));
void m_sort( Type A[ ], Type tempArray[ ], int left, int right, BOOL (*compareFunc)(Type a, Type b));
void merge( Type data[ ], Type tempArray[ ], int lPos, int rPos, int rightEnd, BOOL (*compareFunc)(Type a, Type b));


#define LEFT_CHILD(i)  ( 2 * (i) + 1 )


#endif // __SORTING_ALGORITHMS_H__